#ifndef DAPEXPCONVERT_H
#define DAPEXPCONVERT_H

#include <QObject>
#include <QDebug>

class DapExpConvert : public QObject
{
    Q_OBJECT
public:
    explicit DapExpConvert(QObject *parent = nullptr);

    static bool isExp(const QString &str);
    static bool isDatoshi(const QString &str);
    static QString expToFixed(const QString &src);
    static QString datoshiToCoins(const QString &datoshi);
    static QString coinsToDatoshi(const QString &coins);

private:
    static QString removeNulls(const QString &src);
    static QString setLimitSymbols(const QString &src, int count);
    static bool containsOnlyDigits(const QString &str);
};

#endif // DAPEXPCONVERT_H
