#ifndef DAPNODEINSTALLMANAGER_H
#define DAPNODEINSTALLMANAGER_H

#include <QObject>
#include <QDebug>
#include <QTextCodec>
#include <QFile>
#include <QRegularExpression>
#include <QNetworkAccessManager>
#include <QNetworkRequest>
#include <QNetworkReply>
#include <QTimer>
#include <QFileInfo>
#include <QSysInfo>

class DapNodeInstallManager: public QObject
{
    Q_OBJECT
public:
    explicit DapNodeInstallManager(bool flag_RK, QObject *parent = nullptr);
    ~DapNodeInstallManager();

    void checkUpdateNode(const QString &link);
    QString getUrlForDownload();
    QString getUrl(const QString& ver);

signals:
    void singnalReadyUpdateToNode(bool ready);
private:
    QUrl m_url;
    QString m_baseUrl;
    QString m_labelUrlFile;

    //#ifdef __x86_64__
    //    QString m_latest{"latest-amd64"};
    //#else
    //    QString m_latest{"latest-arm64"};
    //#endif

    QString m_fileName, m_suffix;

    const int TIMEOUT_CHECK_URL = 30000;
};

#endif // DAPNODEINSTALLMANAGER_H
