#ifndef DapNetworkStrSTR_H
#define DapNetworkStrSTR_H

#include <QObject>

class DapNetworkStr: public QObject
{
    Q_OBJECT
public:
    Q_INVOKABLE explicit DapNetworkStr(const QString& a_name, QObject * a_parent = nullptr);
    Q_INVOKABLE explicit DapNetworkStr(QObject * a_parent = nullptr) : QObject(a_parent){}
    Q_INVOKABLE DapNetworkStr(const DapNetworkStr& aNetwork);
    Q_INVOKABLE DapNetworkStr& operator=(const DapNetworkStr& aNetwork);

    Q_PROPERTY(QString  name                            READ getName)
    Q_PROPERTY(QString  networkState                    READ getNetworkState)
    Q_PROPERTY(QString  targetState                     READ getTargetState)
    Q_PROPERTY(QString  stateColor                      READ getStateColor)
    Q_PROPERTY(QString  errorMessage                    READ getErrorMessage)
    Q_PROPERTY(QString  activeLinksCount                READ getActiveLinksCount)
    Q_PROPERTY(QString  linksCount                      READ getLinksCount)
    Q_PROPERTY(QString  nodeAddress                     READ getNodeAddress)

    friend QDataStream& operator << (QDataStream& aOut, const DapNetworkStr& aNetwork);
    friend QDataStream& operator >> (QDataStream& aIn, DapNetworkStr& aNetwork);

    QString getName() const;
    QString getNetworkState() const;
    QString getTargetState() const;
    QString getStateColor() const;
    QString getErrorMessage() const;
    QString getActiveLinksCount() const;
    QString getLinksCount() const;
    QString getNodeAddress() const;

    static QString fromStateStringToShortStateString(const QString &a_state);

    void setName(const QString &a_name);
    void setNetworkState(const QString &a_networkState);
    void setTargetState(const QString &a_targetState);
    void setStateColor(const QString &a_state);
    void setErrorMessage(const QString &a_error);
    void setActiveLinksCount(const QString &a_count);
    void setLinksCount(const QString &a_linksCount);
    void setNodeAddress(const QString &a_nodeAddress);

private:
    QString m_name;
    QString m_networkState;
    QString m_targetState;
    QString m_StateColor;
    QString m_ErrorMessage;
    QString m_linksCount;
    QString m_activeLinksCount;
    QString m_nodeAddress;

    static const QMap<QString, QString> s_stateStrings;
};

#endif // DapNetworkStrSTR_H
