#include "DapWalletHistoryEvent.h"

DapWalletHistoryEvent::DapWalletHistoryEvent(QObject *parent) : QObject(parent)
{
    
}

DapWalletHistoryEvent::DapWalletHistoryEvent(const DapWalletHistoryEvent &aHistoryEvent)
    : QObject(aHistoryEvent.parent()),
      m_sWallet(aHistoryEvent.m_sWallet), m_sNetwork(aHistoryEvent.m_sNetwork),
      m_sName(aHistoryEvent.m_sName),
      m_sAmountWithoutZeros(aHistoryEvent.m_sAmountWithoutZeros),
      m_sDatoshi(aHistoryEvent.m_sDatoshi),
      m_sStatus(aHistoryEvent.m_sStatus),
      m_sDate(aHistoryEvent.m_sDate),
      m_SecsSinceEpoch(aHistoryEvent.m_SecsSinceEpoch),
      m_sTxHash(aHistoryEvent.m_sTxHash)
{

}

DapWalletHistoryEvent &DapWalletHistoryEvent::operator=(const DapWalletHistoryEvent &aHistoryEvent)
{
    m_sWallet = aHistoryEvent.m_sWallet;
    m_sNetwork = aHistoryEvent.m_sNetwork;
    m_sName = aHistoryEvent.m_sName;
    m_sAmountWithoutZeros = aHistoryEvent.m_sAmountWithoutZeros;
    m_sDatoshi = aHistoryEvent.m_sDatoshi;
    m_sStatus = aHistoryEvent.m_sStatus;
    m_sDate = aHistoryEvent.m_sDate;
    m_SecsSinceEpoch = aHistoryEvent.m_SecsSinceEpoch;
    m_sTxHash = aHistoryEvent.m_sTxHash;
    return (*this);
}

bool DapWalletHistoryEvent::operator==(const DapWalletHistoryEvent &aHistoryEvent) const
{
    return (m_sWallet == aHistoryEvent.m_sWallet)
            && (m_sNetwork == aHistoryEvent.m_sNetwork)
            && (m_sName == aHistoryEvent.m_sName)
            && (m_sAmountWithoutZeros == aHistoryEvent.m_sAmountWithoutZeros)
            && (m_sDatoshi == aHistoryEvent.m_sDatoshi)
            && (m_sStatus == aHistoryEvent.m_sStatus)
            && (m_sDate == aHistoryEvent.m_sDate)
            && (m_SecsSinceEpoch == aHistoryEvent.m_SecsSinceEpoch)
            && (m_sTxHash == aHistoryEvent.m_sTxHash);
}

QString DapWalletHistoryEvent::getWallet() const
{
    return m_sWallet;
}

void DapWalletHistoryEvent::setWallet(const QString &sWallet)
{
    m_sWallet = sWallet;

    emit walletChanged(m_sWallet);
}

QString DapWalletHistoryEvent::getNetwork() const
{
    return m_sNetwork;
}

void DapWalletHistoryEvent::setNetwork(const QString &sNetwork)
{
    m_sNetwork = sNetwork;

    emit nameChanged(m_sNetwork);
}


QString DapWalletHistoryEvent::getName() const
{
    return m_sName;
}

void DapWalletHistoryEvent::setName(const QString &sName)
{
    m_sName = sName;

    emit nameChanged(m_sName);
}

QString DapWalletHistoryEvent::getAmountWithoutZeros() const
{
    return m_sAmountWithoutZeros;
}

void DapWalletHistoryEvent::setAmountWithoutZeros(const QString &sAmountWithoutZeros)
{
    m_sAmountWithoutZeros = sAmountWithoutZeros;

    emit amountWithoutZerosChanged(m_sAmountWithoutZeros);
}

QString DapWalletHistoryEvent::getDatoshi() const
{
    return m_sDatoshi;
}

void DapWalletHistoryEvent::setDatoshi(const QString &sDatoshi)
{
    m_sDatoshi = sDatoshi;

    emit datoshiChanged(m_sDatoshi);
}

QString DapWalletHistoryEvent::getStatus() const
{
    return m_sStatus;
}

void DapWalletHistoryEvent::setStatus(const QString &sStatus)
{
    m_sStatus = sStatus;

    emit statusChanged(m_sStatus);
}

QString DapWalletHistoryEvent::getDate() const
{
    return m_sDate;
}

void DapWalletHistoryEvent::setDate(const QString &sDate)
{
    m_sDate = sDate;

    emit dateChanged(m_sDate);
}

qint64 DapWalletHistoryEvent::getSecsSinceEpoch() const
{
    return m_SecsSinceEpoch;
}

void DapWalletHistoryEvent::setSecsSinceEpoch(qint64 iSecsSinceEpoch)
{
    m_SecsSinceEpoch = iSecsSinceEpoch;

    emit secsSinceEpochChanged(m_SecsSinceEpoch);
}

QString DapWalletHistoryEvent::getHash() const
{
    return m_sTxHash;
}

void DapWalletHistoryEvent::setHash(const QString &sHash)
{
    m_sTxHash = sHash;

    emit dateChanged(m_sTxHash);
}


QDataStream& operator << (QDataStream& aOut, const DapWalletHistoryEvent& aHistoryEvent)
{
    aOut << aHistoryEvent.m_sWallet
         << aHistoryEvent.m_sNetwork
         << aHistoryEvent.m_sName
         << aHistoryEvent.m_sAmountWithoutZeros
         << aHistoryEvent.m_sDatoshi
         << aHistoryEvent.m_sStatus
         << aHistoryEvent.m_sDate
         << aHistoryEvent.m_SecsSinceEpoch
         << aHistoryEvent.m_sTxHash;
    return aOut;
}

QDataStream& operator >> (QDataStream& aOut, DapWalletHistoryEvent& aHistoryEvent)
{
    aOut >> aHistoryEvent.m_sWallet
         >> aHistoryEvent.m_sNetwork
         >> aHistoryEvent.m_sName
         >> aHistoryEvent.m_sAmountWithoutZeros
         >> aHistoryEvent.m_sDatoshi
         >> aHistoryEvent.m_sStatus
         >> aHistoryEvent.m_sDate
         >> aHistoryEvent.m_SecsSinceEpoch
         >> aHistoryEvent.m_sTxHash;
    return aOut;
}
