#ifndef DAPWALLETHISTORYEVENT_H
#define DAPWALLETHISTORYEVENT_H

#include <QObject>
#include <QString>
#include <QDataStream>

class DapWalletHistoryEvent : public QObject
{
    Q_OBJECT

    QString m_sWallet;

    QString m_sNetwork;
    /// Token name.
    QString m_sName;

    QString m_sAmountWithoutZeros;

    QString m_sDatoshi;

//    double  m_dAmount {0.0};

    QString  m_sStatus;

    QString m_sDate;

    qint64 m_SecsSinceEpoch;

    QString m_sTxHash;

public:
    explicit DapWalletHistoryEvent(QObject *parent = nullptr);
    DapWalletHistoryEvent(const DapWalletHistoryEvent& aHistoryEvent);
    DapWalletHistoryEvent& operator=(const DapWalletHistoryEvent& aHistoryEvent);
    bool operator==(const DapWalletHistoryEvent& aHistoryEvent) const;

    Q_PROPERTY(QString Wallet MEMBER m_sWallet READ getWallet WRITE setWallet NOTIFY walletChanged)
    Q_PROPERTY(QString Network MEMBER m_sNetwork READ getNetwork WRITE setNetwork NOTIFY networkChanged)
    Q_PROPERTY(QString Name MEMBER m_sName READ getName WRITE setName NOTIFY nameChanged)
    Q_PROPERTY(QString AmountWithoutZeros MEMBER m_sName READ getAmountWithoutZeros WRITE setAmountWithoutZeros NOTIFY amountWithoutZerosChanged)
    Q_PROPERTY(QString Datoshi MEMBER m_sName READ getDatoshi WRITE setDatoshi NOTIFY datoshiChanged)
    Q_PROPERTY(QString Status MEMBER m_sName READ getStatus WRITE setStatus NOTIFY statusChanged)
    Q_PROPERTY(QString Date MEMBER m_sDate READ getDate WRITE setDate NOTIFY dateChanged)
    Q_PROPERTY(qint64 SecsSinceEpoch MEMBER m_SecsSinceEpoch READ getSecsSinceEpoch WRITE setSecsSinceEpoch NOTIFY secsSinceEpochChanged)
    Q_PROPERTY(QString Hash MEMBER m_sTxHash READ getHash WRITE setHash NOTIFY hashChanged)

    friend QDataStream& operator << (QDataStream& aOut, const DapWalletHistoryEvent& aHistoryEvent);
    friend QDataStream& operator >> (QDataStream& aOut, DapWalletHistoryEvent& aHistoryEvent);

signals:
    void walletChanged(const QString& asWallet);
    void networkChanged(const QString& asNetwork);
    void nameChanged(const QString& asName);
    void amountWithoutZerosChanged(const QString& asAmountWithoutZeros);
    void datoshiChanged(const QString& asDatoshi);
    void statusChanged(const QString& asStatus);
    void dateChanged(const QString& asDate);
    void secsSinceEpochChanged(qint64 aSecsSinceEpoch);
    void hashChanged(const QString& asHash);

public slots:
    QString getWallet() const;
    void setWallet(const QString &sWallet);
    QString getNetwork() const;
    void setNetwork(const QString &sNetwork);
    QString getName() const;
    void setName(const QString &sName);
    QString getAmountWithoutZeros() const;
    void setAmountWithoutZeros(const QString &sAmountWithoutZeros);
    QString getDatoshi() const;
    void setDatoshi(const QString &sDatoshi);
    QString getStatus() const;
    void setStatus(const QString &sStatus);
    QString getDate() const;
    void setDate(const QString &sDate);
    qint64 getSecsSinceEpoch() const;
    void setSecsSinceEpoch(qint64 iSecsSinceEpoch);
    QString getHash() const;
    void setHash(const QString &sHash);
};

#endif // DAPWALLETHISTORYEVENT_H
