#include "DapWalletToken.h"

DapWalletToken::DapWalletToken(const QString &asName, QObject *parent)
    : QObject(parent), m_sName(asName)
{
    
}

DapWalletToken::DapWalletToken(const DapWalletToken &aToken)
    : QObject(aToken.parent()), m_sName(aToken.m_sName),
      m_sFullBalance(aToken.m_sFullBalance),
      m_sBalanceWithoutZeros(aToken.m_sBalanceWithoutZeros),
      m_sDatoshi(aToken.m_sDatoshi),
      m_sNetwork(aToken.m_sNetwork)
{

}

DapWalletToken &DapWalletToken::operator=(const DapWalletToken &aToken)
{
    m_sName = aToken.m_sName;
    m_sFullBalance = aToken.m_sFullBalance;
    m_sBalanceWithoutZeros = aToken.m_sBalanceWithoutZeros;
    m_sDatoshi = aToken.m_sDatoshi;
    m_sNetwork = aToken.m_sNetwork;
    return (*this);
}

bool DapWalletToken::operator==(const DapWalletToken &aToken) const
{
    return m_sName == aToken.m_sName
         && m_sFullBalance == aToken.m_sFullBalance
         && m_sBalanceWithoutZeros == aToken.m_sBalanceWithoutZeros
         && m_sDatoshi == aToken.m_sDatoshi
         && m_sNetwork == aToken.m_sNetwork;
}

QString DapWalletToken::getName() const
{
    return m_sName;
}

void DapWalletToken::setName(const QString &sName)
{
    m_sName = sName;

    emit nameChanged(m_sName);
}

QString DapWalletToken::getFullBalance() const
{
    return m_sFullBalance;
}

void DapWalletToken::setFullBalance(const QString &sFullBalance)
{
    m_sFullBalance = sFullBalance;

    emit fullBalanceChanged(m_sFullBalance);
}

QString DapWalletToken::getBalanceWithoutZeros() const
{
    return m_sBalanceWithoutZeros;
}

void DapWalletToken::setBalanceWithoutZeros(const QString &sBalanceWithoutZeros)
{
    m_sBalanceWithoutZeros = sBalanceWithoutZeros;

    emit balanceWithoutZerosChanged(m_sBalanceWithoutZeros);
}

QString DapWalletToken::getDatoshi() const
{
    return m_sDatoshi;
}

void DapWalletToken::setDatoshi(const QString &sDatoshi)
{
    m_sDatoshi = sDatoshi;

    emit datoshiChanged(m_sDatoshi);
}

QString DapWalletToken::getNetwork() const
{
    return m_sNetwork;
}

void DapWalletToken::setNetwork(const QString &sNetwork)
{
    m_sNetwork = sNetwork;

    emit networkChanged(m_sNetwork);
}

QString DapWalletToken::getIcon() const
{
    return m_sIcon;
}

void DapWalletToken::setIcon(const QString &sIcon)
{
    m_sIcon = sIcon;

    emit iconChanged(m_sIcon);
}

QDataStream& operator << (QDataStream& aOut, const DapWalletToken& aToken)
{
    aOut << aToken.m_sName
         << aToken.m_sFullBalance
         << aToken.m_sBalanceWithoutZeros
         << aToken.m_sDatoshi
         << aToken.m_sNetwork;
    return aOut;
}

QDataStream& operator >> (QDataStream& aOut, DapWalletToken& aToken)
{
    aOut >> aToken.m_sName
         >> aToken.m_sFullBalance
         >> aToken.m_sBalanceWithoutZeros
         >> aToken.m_sDatoshi
         >> aToken.m_sNetwork;
    return aOut;
}


