#ifndef DAPWALLETTOKEN_H
#define DAPWALLETTOKEN_H

#include <QObject>
#include <QString>
#include <QDataStream>

class DapWalletToken : public QObject
{
    Q_OBJECT

    /// Token name.
    QString m_sName;
    QString m_sFullBalance;
    QString m_sBalanceWithoutZeros;
    QString m_sDatoshi;
    /// Token balance.
//    double  m_dBalance {0.0};
    /// Token emission.
//    quint64 m_iEmission {0};
    /// Network.
    QString m_sNetwork;
    /// Icon path.
    QString m_sIcon;

public:
    explicit DapWalletToken(const QString& asName = QString(), QObject *parent = nullptr);
    DapWalletToken(const DapWalletToken& aToken);
    DapWalletToken& operator=(const DapWalletToken& aToken);
    bool operator==(const DapWalletToken& aToken) const;

    Q_PROPERTY(QString Name MEMBER m_sName READ getName WRITE setName NOTIFY nameChanged)
    Q_PROPERTY(QString FullBalance MEMBER m_sFullBalance READ getFullBalance WRITE setFullBalance NOTIFY fullBalanceChanged)
    Q_PROPERTY(QString BalanceWithoutZeros MEMBER m_sBalanceWithoutZeros READ getBalanceWithoutZeros WRITE setBalanceWithoutZeros NOTIFY balanceWithoutZerosChanged)
    Q_PROPERTY(QString Datoshi MEMBER m_sDatoshi READ getDatoshi WRITE setDatoshi NOTIFY datoshiChanged)
    Q_PROPERTY(QString Network MEMBER m_sNetwork READ getNetwork WRITE setNetwork NOTIFY networkChanged)
    Q_PROPERTY(QString Icon MEMBER m_sIcon READ getIcon WRITE setIcon NOTIFY iconChanged)


    friend QDataStream& operator << (QDataStream& aOut, const DapWalletToken& aToken);
    friend QDataStream& operator >> (QDataStream& aOut, DapWalletToken& aToken);

signals:
    void nameChanged(const QString & asName);
    void fullBalanceChanged(const QString & asFullBalance);
    void balanceWithoutZerosChanged(const QString & asBalanceWithoutZeros);
    void datoshiChanged(const QString & asDatoshi);
    void networkChanged(const QString &asNetwork);
    void iconChanged(const QString &asIcon);

public slots:
    QString getName() const;
    void setName(const QString &sName);
    QString getFullBalance() const;
    void setFullBalance(const QString &sFullBalance);
    QString getBalanceWithoutZeros() const;
    void setBalanceWithoutZeros(const QString &sBalanceWithoutZeros);
    QString getDatoshi() const;
    void setDatoshi(const QString &sDatoshi);
    QString getNetwork() const;
    void setNetwork(const QString &sNetwork);
    QString getIcon() const;
    void setIcon(const QString &sIcon);
};

Q_DECLARE_METATYPE(DapWalletToken)

#endif // DAPWALLETTOKEN_H
