#ifndef DAPREGULARREQUESTSCONTROLLER_H
#define DAPREGULARREQUESTSCONTROLLER_H

#include <QObject>
#include <QTimer>
#include <QByteArray>
#include "handlers/DapCommandList.h"

#include "DapNodePathManager.h"


class DapRegularRequestsController : public QObject
{
    Q_OBJECT
public:
    DapRegularRequestsController(QObject *parent = nullptr);
    ~DapRegularRequestsController();

    void start();
    const QMap<QString,QString>& getListWallets() const {return m_listWallets;}
    const QMap<QString, NetworkSpace::FeeInfoStruct>& getFee() const;
    const QStringList& getNetworkList() const {return m_networkList;}
    const QString& getVersion();

signals:
    void versionNodeUpadeted();
    void needReinit();
public slots:
    void notifyWatcherRespond(QVariant nodeStatus);
private slots:
    void updateListNetworks();
    void updateListWallets();
    void updateFeeInfo();
    void updateVersion();
private:
    /// Compare it with current to send signals only if them different
    bool compareWithLastRespond(const QVariant &current, QByteArray &last);
private:
    QMap<QString, NetworkSpace::FeeInfoStruct> m_feeInfoConteiner;
    QMap<QString,QString> m_listWallets;
    QStringList m_networkList;
    QString m_version = "";
    QString notifyStatusConnect{QAbstractSocket::SocketState::UnconnectedState};

    DapCommandList *m_cmdList = nullptr;

    QTimer *m_timerUpdateListWallets = nullptr;
    QTimer *m_timerUpdateFee = nullptr;
    QTimer *m_timerUpdateNetList = nullptr;

    QByteArray m_lastRespondWallets;

    const int WALLETLIST_COUNT = 10000;
    const int FEE_TIMER = 30000;
    const int NETLIST_TIMER = 10000;
};

#endif // DAPREGULARREQUESTSCONTROLLER_H
