#ifndef HELPDICTIONARYCONTROLLER_H
#define HELPDICTIONARYCONTROLLER_H

#include <QString>
#include <QStringList>
#include "TreeDictionaryBase.h"


class HelpDictionaryController
{
public:
    HelpDictionaryController();
    ~HelpDictionaryController();

    void setDictionary(const QJsonObject &tree);
    bool isDictionary();

    void setData(const QJsonObject &jData);
    void setNodeVersion(const QString& version){m_nodeVersion = version;}
    const QString& getNodeVersion() {return m_nodeVersion;}

    QStringList getHelpList(const QString& text, int cursorPosition);
private:
    void getDictionary();

    QStringList getListVariants(const QString &text);
    QStringList getListParamrtrs(const QString& wallet, const QString& net, const QStringList &curData);

    inline bool isHasCorrList(const QStringList& currentList, const QStringList *testList) const;
    inline void variantList(const QStringList& currentList, QVector<const QStringList *>& currentVariants);

private:
    TreeDictionaryBase* m_treeDictionary = nullptr;

    QString m_nodeVersion = "";

    QStringList m_wallets;
    QStringList m_networks;
    QStringList m_pubCertName;
    QStringList m_privCertName;
    // network chains
    QMap<QString, QStringList> m_chains;
    // <wallet, network>, tickers
    QMap<QPair<QString, QString>, QStringList> m_tokensTicker;
    // net, tickers
    QMap<QString, QStringList> m_mempoolTokensTicker;
};

#endif // HELPDICTIONARYCONTROLLER_H
