#include "DapAddNodeCommand.h"

DapAddNodeCommand::DapAddNodeCommand(const QString &asServicename, QObject *parent, const QString &asCliPath)
    : DapAbstractCommand(asServicename, parent, asCliPath)
{
}


/// Send a response to the client.
/// @details Performed on the service side.
/// @param arg1...arg10 Parameters.
/// @return Reply to client.
QVariant DapAddNodeCommand::respondToClient(const QVariant &args)
{
    DapAbstractCommand::respondToClient(args);

    QJsonObject resultObj;
    auto params = args.toStringList();
    if(params.contains(WEB3_KEY))
    {
        auto result = cmdList->addNode(args).toString();

        if(!result.isEmpty())
        {
            if(result.simplified() == "Successfully added")
            {
                resultObj.insert(RESULT_KEY, QString("node added"));
            }
            else
            {
                resultObj.insert(ERROR_KEY, result);
            }
        }
        else
        {
            resultObj.insert(ERROR_KEY, QString("Node is offline"));
        }

        addWeb3Result(resultObj, args);
    }
    else
    {
        auto result = cmdList->addNodeCommand(args).toString();
        qDebug() << "[DapAddNodeCommand] result: " << result;
        if(!result.isEmpty())
        {
            if(result.contains("Successfully added"))
            {
                resultObj.insert(RESULT_KEY, QString("successfully"));
            }
            else
            {
                resultObj.insert(ERROR_KEY, result);
            }
        }
        else
        {
            resultObj.insert(ERROR_KEY, QString("Node is offline"));
        }
    }

    QJsonDocument resultDoc(resultObj);
    return resultDoc.toJson();
}
