#include "DapCreatePassForWallet.h"

DapCreatePassForWallet::DapCreatePassForWallet(const QString &asServicename, QObject *parent, const QString &asCliPath)
    : DapAbstractCommand(asServicename, parent, asCliPath)
{

}

/// Send a response to the client.
/// @details Performed on the service side.
/// @param arg1...arg10 Parameters.
/// @return Reply to client.
QVariant DapCreatePassForWallet::respondToClient(const QVariant &args)
{
    qDebug() << "[" << this->getName() << "] [respondToClient]";

    QStringList params = args.toStringList();

    if(params.first().isEmpty())
    {
        QJsonDocument resultDoc(QJsonObject({{RESULT_KEY, QString("Error, password is not created")}}));
        return resultDoc.toJson();
    }

    QVariant v_res = cmdList->createPassForWallet(args);

    if(v_res.type() == QMetaType::QJsonDocument) {
        // if json
        qWarning() << "NEED JSON PARSING";
        //TODO
    }
    else
    {
        // if string
        QString result = v_res.toString();
        if(result.contains(SUCCESSFULL_MESSAGE))
        {
            QJsonDocument resultDoc(QJsonObject({{RESULT_KEY, QString("Success")}}));
            return resultDoc.toJson();
        }
    }

    QJsonDocument resultDoc(QJsonObject({{RESULT_KEY, QString("Error, password is not created")}}));
    return resultDoc.toJson();
}

void DapCreatePassForWallet::replyFromService()
{
    DapRpcServiceReply *reply = static_cast<DapRpcServiceReply *>(sender());
    QVariant replyVariant = reply->response().toJsonValue().toVariant();

    QJsonDocument replyDoc = QJsonDocument::fromJson(replyVariant.toByteArray());
    QJsonObject replyObj = replyDoc.object();
    QString resultStr = replyObj[RESULT_KEY].toString();

    emit serviceResponded(resultStr);
}
