#ifndef DAPCREATEPASSFORWALLET_H
#define DAPCREATEPASSFORWALLET_H

#include "DapAbstractCommand.h"
#include <QRegularExpression>

class DapCreatePassForWallet : public DapAbstractCommand
{
public:
    DapCreatePassForWallet(const QString &asServicename, QObject *parent = nullptr, const QString &asCliPath = QString());

public slots:
    /// Send a response to the client.
    /// @details Performed on the service side.
    /// @param arg1...arg10 Parameters.
    /// @return Reply to client.
    QVariant respondToClient(const QVariant &args = QVariant()) override;
    /// Reply from service.
    /// @details Performed on the service side.
    /// @return Service reply.
    void replyFromService() override;

private:
    const QString SUCCESSFULL_MESSAGE = "successfully converted";
};

#endif // DAPCREATEPASSFORWALLET_H
