#ifndef DAPCREATEVPNORDER_H
#define DAPCREATEVPNORDER_H

#include <QProcess>
#include <QString>

#include "DapAbstractCommand.h"

class DapCreateVPNOrder : public DapAbstractCommand
{
public:
    /// Overloaded constructor.
    /// @param asServiceName Service name.
    /// @param parent Parent.
    /// @details The parent must be either DapRPCSocket or DapRPCLocalServer.
    explicit DapCreateVPNOrder(const QString &asServicename, QObject *parent = nullptr, const QString &asCliPath = QString());

public slots:
    /// Send a response to the client.
    /// @details Performed on the service side.
    /// @param arg1...arg10 Parameters.
    /// @return Reply to client.
    QVariant respondToClient(const QVariant &args = QVariant()) override;
    /// Reply from service.
    /// @details Performed on the service side.
    /// @return Service reply.
    void replyFromService() override;
private:
    const QRegularExpression REGULAR_HASH = QRegularExpression(R"(Created order (.\S+))");

    const QString HASH = "hash";
signals:

};

#endif // DAPCREATEVPNORDER_H
