#include "DapExportLogCommand.h"

/// Overloaded constructor.
/// @param asServiceName Service name.
/// @param apSocket Client connection socket with service.
/// @param parent Parent.
DapExportLogCommand::DapExportLogCommand(const QString &asServicename, QObject *parent)
    : DapAbstractCommand(asServicename, parent)
{

}

/// Send a response to the client.
/// A log file is saved from the GUI window.
/// @param arg1...arg10 Parameters.
/// @return Reply to client.
QVariant DapExportLogCommand::respondToClient(const QVariant &args)
{
    DapAbstractCommand::respondToClient(args);

    QStringList params = args.toStringList();

    QFile newFile(params[1]);
    if(newFile.open(QIODevice::ReadOnly | QIODevice::Text))
        newFile.remove();

    bool result = QFile::copy(params[0], params[1]);

    QJsonDocument resultDoc(QJsonObject({{RESULT_KEY, result}}));
    return resultDoc.toJson();
}

void DapExportLogCommand::replyFromService()
{
    DapRpcServiceReply *reply = static_cast<DapRpcServiceReply *>(sender());
    QVariant replyVariant = reply->response().toJsonValue().toVariant();

    QJsonDocument replyDoc = QJsonDocument::fromJson(replyVariant.toByteArray());
    QJsonObject replyObj = replyDoc.object();
    bool resultBool = replyObj[RESULT_KEY].toBool();

    emit serviceResponded(resultBool);
}
