#ifndef DAPSAVELOGCOMMAND_H
#define DAPSAVELOGCOMMAND_H

#include <QFile>

#include "DapAbstractCommand.h"

class DapExportLogCommand : public DapAbstractCommand
{

public:
    /// Overloaded constructor.
    /// @param asServiceName Service name.
    /// @param apSocket Client connection socket with service.
    /// @param parent Parent.
    explicit DapExportLogCommand(const QString &asServicename, QObject *parent = nullptr);

public slots:
    /// Send a response to the client.
    /// /// A log file is saved from the GUI window.
    /// @param arg1...arg10 Parameters.
    /// @return Reply to client.
    QVariant respondToClient(const QVariant &args = QVariant()) override;
    /// Reply from service.
    /// @details Performed on the service side.
    /// @return Service reply.
    void replyFromService() override;
};

#endif // DAPSAVELOGCOMMAND_H
