#ifndef DAPGETALLWALLETHISTORYCOMMAND_H
#define DAPGETALLWALLETHISTORYCOMMAND_H

#include "DapGetAllWalletHistoryCommandBase.h"

class DapGetAllWalletHistoryCommand : public DapGetAllWalletHistoryCommandBase
{
    Q_OBJECT

public:
    /// Overloaded constructor.
    /// @param asServiceName Service name.
    /// @param parent Parent.
    /// @details The parent must be either DapRPCSocket or DapRPCLocalServer.
    /// @param asCliPath The path to cli nodes.
    DapGetAllWalletHistoryCommand(const QString &asServicename, QObject *parent = nullptr, const QString &asCliPath = QString());

public slots:
    /// Send a response to the client.
    /// @details Performed on the service side.
    /// @param arg1 Network array. Format "<network name 1>:<chain 1>:<address 1>/<network name 2>:<chain 2>:<address 2>/..."
    /// @return Reply to client.
    QVariant respondToClient(const QVariant &args = QVariant()) override;

    void transactionFromQueudAdded(const QVariant& args);
protected:
    void mempoolTransactionMoved(const QString& network, const QString& walletName, const QString& hash, const QString& ladgerTs = "") override;

signals:
    void transactionMoved(const QVariant& params);

private:
    QByteArray _lastResult;
    bool isWalletActivated(QString wallet);
    ///  network       wallet         hash     isNeedTest
    QMap<QString, QMap<QString, QPair<QString, bool>>> m_transactionFromQueued;
};

#endif // DAPGETALLWALLETHISTORYCOMMAND_H
