#ifndef DAPGETFEECOMMAND_H
#define DAPGETFEECOMMAND_H

#include "DapAbstractCommand.h"
#include <QRegularExpression>

class DapGetFeeCommand : public DapAbstractCommand
{
public:
    DapGetFeeCommand(const QString &asServicename, QObject *parent = nullptr, const QString &asCliPath = QString());

public slots:
    /// Send a response to the client.
    /// @details Performed on the service side.
    /// @param arg1...arg10 Parameters.
    /// @return Reply to client.
    QVariant respondToClient(const QVariant &args = QVariant()) override;
    /// Reply from service.
    /// @details Performed on the service side.
    /// @return Service reply.
    void replyFromService() override;
};

#endif // DAPGETFEECOMMAND_H
