#ifndef DAPGETLISTORDERSCOMMAND_H
#define DAPGETLISTORDERSCOMMAND_H

#include <QProcess>
#include <QRegExp>
#include <QRegularExpression>
#include <QByteArray>
#include <QDataStream>
#include <QBuffer>
#include <QTextCodec>

#include "DapAbstractCommand.h"
#include "DapVpnOrder.h"

class DapGetListOrdersCommand : public DapAbstractCommand
{
public:

//    На текущий момент задействованы следующие ID:
//        1 - VPN
//        2 - xchange
//        3 - старый формат pos_delegate, 0x13 - новый формат
//        5 - недописанный datum
//        0x12 - stake_lock

    struct srv_uid{
        QString vpn   = "0x0000000000000001";
        QString stake = "0x0000000000000013";
    }uids;

    const QRegularExpression REGULAR_MEMPOOL_TIME = QRegularExpression(R"((\w{2}) (\w{3}) (\w{2}) (.+))");
    const QStringList MONTH_LIST {"Jan", "Feb", "Mar", "Apr", "May", "Jun", "Jul", "Aug", "Sep", "Oct", "Nov", "Dec"};


    /// Overloaded constructor.
    /// @param asServiceName Service name.
    /// @param parent Parent.
    /// @details The parent must be either DapRPCSocket or DapRPCLocalServer.
    /// @param asCliPath The path to cli nodes.
    DapGetListOrdersCommand(const QString &asServicename, QObject *parent = nullptr, const QString &asCliPath = QString());

public slots:
    /// Send a response to the client.
    /// @details Performed on the service side.
    /// @param arg1...arg10 Parameters.
    /// @return Reply to client.
    QVariant respondToClient(const QVariant &args = QVariant()) override;
};

#endif // DAPGETLISTORDERSCOMMAND_H
