#include "DapGetNodeStatus.h"

DapGetNodeStatus::DapGetNodeStatus(const QString &asServicename, QObject *parent, const QString &asCliPath)
    : DapAbstractCommand(asServicename, parent, asCliPath)
{
}


/// Send a response to the client.
/// @details Performed on the service side.
/// @param arg1...arg10 Parameters.
/// @return Reply to client.
QVariant DapGetNodeStatus::respondToClient(const QVariant &args)
{
    DapAbstractCommand::respondToClient(args);

    QStringList params = args.toStringList();
    QString status = params[0];
    QJsonObject resultObj;

    if(status != "Offline")
    {
        resultObj.insert(RESULT_KEY, status);
    }
    else
    {
        resultObj.insert(ERROR_KEY, status);
    }

    addWeb3Result(resultObj, args);
    QJsonDocument resultDoc(resultObj);
    return resultDoc.toJson();
}
