#include "DapGetServiceLimitsCommand.h"

DapGetServiceLimitsCommand::DapGetServiceLimitsCommand(const QString &asServicename, QObject *parent, const QString &asCliPath)
    : DapAbstractCommand(asServicename, parent, asCliPath)
{
}


/// Send a response to the client.
/// @details Performed on the service side.
/// @param arg1...arg10 Parameters.
/// @return Reply to client.
QVariant DapGetServiceLimitsCommand::respondToClient(const QVariant &args)
{
    DapAbstractCommand::respondToClient(args);

    QJsonObject resultObj;
    QJsonObject data;

    auto result = cmdList->getServiceLimits(args).toString();

    bool isBadData = false;

    QRegularExpression regularSEC(R"(SEC: (\S+))");
    QRegularExpressionMatch matchSEC = regularSEC.match(result);
    if(matchSEC.hasMatch())
    {
        data.insert("SEC", matchSEC.captured(1));
    }
    else
    {
        isBadData = true;
    }

    QRegularExpression regularBYTES(R"(BYTES: (\S+))");
    QRegularExpressionMatch matchBYTES = regularBYTES.match(result);
    if(matchBYTES.hasMatch())
    {
        data.insert("BYTES", matchBYTES.captured(1));
    }
    else
    {
        isBadData = true;
    }

    if(isBadData)
    {
        resultObj.insert(ERROR_KEY, result);
    }
    else
    {
        resultObj.insert(RESULT_KEY, data);
    }

    addWeb3Result(resultObj, args);
    QJsonDocument resultDoc(resultObj);
    return resultDoc.toJson();
}
