#ifndef DAPGETWALLETADDRESSESCOMMAND_H
#define DAPGETWALLETADDRESSESCOMMAND_H

#include <QProcess>

#include "DapAbstractCommand.h"

class DapGetWalletAddressesCommand : public DapAbstractCommand
{
public:
    /// Overloaded constructor.
    /// @param asServiceName Service name.
    /// @param parent Parent.
    /// @details The parent must be either DapRPCSocket or DapRPCLocalServer.
    DapGetWalletAddressesCommand(const QString &asServicename, QObject *parent = nullptr, const QString &asCliPath = QString());

public slots:
    /// Send request to service.
    /// @details Performed on the client side.
    /// @param arg1...arg10 Parameters.
    Q_INVOKABLE virtual void requestToService(const QVariant &args = QVariant()) override;
    /// Send a response to the client.
    /// @details Performed on the service side.
    /// @param arg1...arg10 Parameters.
    /// @return Reply to client.
    QVariant respondToClient(const QVariant &args = QVariant()) override;
    /// Reply from service.
    /// @details Performed on the service side.
    /// @return Service reply.
    void replyFromService() override;
};

#endif // DAPGETWALLETADDRESSESCOMMAND_H
