#ifndef DAPGETWALLETTOKENINFOCOMMAND_H
#define DAPGETWALLETTOKENINFOCOMMAND_H

#include <QProcess>
#include <QRegExp>

#include "DapAbstractCommand.h"

class DapGetWalletTokenInfoCommand : public DapAbstractCommand
{
public:
    /// Overloaded constructor.
    /// @param asServiceName Service name.
    /// @param parent Parent.
    /// @details The parent must be either DapRPCSocket or DapRPCLocalServer.
    DapGetWalletTokenInfoCommand(const QString &asServicename, QObject *parent = nullptr, const QString &asCliPath = QString());

public slots:
    /// Send a response to the client.
    /// @details Performed on the service side.
    /// @param arg1...arg10 Parameters.
    /// @return Reply to client.
    QVariant respondToClient(const QVariant &args = QVariant()) override;
    /// Reply from service.
    /// @details Performed on the service side.
    /// @return Service reply.
    void replyFromService() override;
};

#endif // DAPGETWALLETTOKENINFOCOMMAND_H
