#ifndef DAPGETXCHANGEORDERSLIST_H
#define DAPGETXCHANGEORDERSLIST_H

#include <QProcess>
#include <QRegExp>
#include <QRegularExpression>
#include <QByteArray>
#include <QJsonArray>
#include <QJsonObject>
#include <QJsonDocument>

#include "DapAbstractCommand.h"

class DapGetXchangeOrdersList : public DapAbstractCommand
{
public:
    DapGetXchangeOrdersList(const QString &asServicename, QObject *parent = nullptr, const QString &asCliPath = QString());

public slots:
    /// Send a response to the client.
    /// @details Performed on the service side.
    /// @param arg1...arg10 Parameters.
    /// @return Reply to client.
    QVariant respondToClient(const QVariant &args) override;
    /// Reply from service.
    /// @details Performed on the service side.
    /// @return Service reply.
    void replyFromService() override;
};

#endif // DAPGETXCHANGEORDERSLIST_H
