#ifndef DAPGETXCHANGETOKENPAIR_H
#define DAPGETXCHANGETOKENPAIR_H

#include <QProcess>
#include <QRegExp>
#include <QRegularExpression>
#include <QByteArray>
#include <QJsonArray>
#include <QJsonObject>
#include <QJsonDocument>

#include "DapAbstractCommand.h"

class DapGetXchangeTokenPair : public DapAbstractCommand
{
public:
    DapGetXchangeTokenPair(const QString &asServicename, QObject *parent = nullptr, const QString &asCliPath = QString());

public slots:
    /// Send a response to the client.
    /// @details Performed on the service side.
    /// @param arg1...arg10 Parameters.
    /// @return Reply to client.
    QVariant respondToClient(const QVariant &args = QVariant()) override;
    /// Reply from service.
    /// @details Performed on the service side.
    /// @return Service reply.
    void replyFromService() override;

private:
    QString lastResult;
};

#endif // DAPGETXCHANGETOKENPAIR_H
