#ifndef DAPGETXCHANGETOKENPRICEHISTORY_H
#define DAPGETXCHANGETOKENPRICEHISTORY_H

#include <QProcess>
#include <QRegExp>
#include <QRegularExpression>
#include <QByteArray>
#include <QJsonArray>
#include <QJsonObject>
#include <QJsonDocument>
#include <QDateTime>
#include <QLocale>

#include "DapAbstractCommand.h"

class DapGetXchangeTokenPriceHistory : public DapAbstractCommand
{

public:
    DapGetXchangeTokenPriceHistory(const QString &asServicename, QObject *parent = nullptr, const QString &asCliPath = QString());

public slots:
    /// Send a response to the client.
    /// @details Performed on the service side.
    /// @param arg1...arg10 Parameters.
    /// @return Reply to client.
    QVariant respondToClient(const QVariant &args = QVariant()) override;
    /// Reply from service.
    /// @details Performed on the service side.
    /// @return Service reply.
    void replyFromService() override;

private:
    const QString TYPE_ORDERS = "changed";

    const QString RETURNED_TEXT = "returned";

    const QRegularExpression REG_HASH = QRegularExpression(R"(Hash: (.+))");
    const QRegularExpression REG_TIME = QRegularExpression(R"(ts_created: (\w{3}, \d{2} \w{3} \d{4} \d{2}:\d{2}:\d{2} \+\d{4}))");
    const QRegularExpression REG_RATE = QRegularExpression(R"(,  rate \((\S+)\/(\S+)\): (\S+),)");
    const QRegularExpression REG_RETURN = QRegularExpression(R"(returned (.+) to owner from order (.\S+))");
};

#endif // DAPGETXCHANGETOKENPRICEHISTORY_H
