#ifndef DAPMEMPOOLLISTCOMMAND_H
#define DAPMEMPOOLLISTCOMMAND_H

#include "DapGetAllWalletHistoryCommandBase.h"

class DapMempoolListCommand : public DapGetAllWalletHistoryCommandBase
{
public:
    /// Overloaded constructor.
    /// @param asServiceName Service name.
    /// @param parent Parent.
    /// @details The parent must be either DapRPCSocket or DapRPCLocalServer.
    /// @param asCliPath The path to cli nodes.
    DapMempoolListCommand(const QString &asServicename, QObject *parent = nullptr, const QString &asCliPath = QString());

public slots:
    /// Send a response to the client.
    /// @details Performed on the service side.
    /// @param arg1 Network array. Format "<network name 1>:<chain 1>:<address 1>/<network name 2>:<chain 2>:<address 2>/..."
    /// @return Reply to client.
    QVariant respondToClient(const QVariant &args = QVariant()) override;

};

#endif // DAPMEMPOOLLISTCOMMAND_H
