#ifndef DAPNETIDCOMMAND_H
#define DAPNETIDCOMMAND_H

#include <QObject>
#include <QProcess>
#include <QString>
#include <QTextCodec>
#include <QCoreApplication>
#include <QFile>
#include <QProcess>
#include <QTimer>

#include "DapAbstractCommand.h"

class DapNetIdCommand : public DapAbstractCommand
{
public:
    explicit DapNetIdCommand(const QString &asServicename, QObject *parent = nullptr, const QString &asCliPath = QString());

public slots:
    /// Send a response to the client.
    /// @details Performed on the service side.
    /// @param arg1...arg10 Parameters.
    /// @return Reply to client.
    QVariant respondToClient(const QVariant &args = QVariant()) override;
    /// Reply from service.
    /// @details Performed on the service side.
    /// @return Service reply.
    void replyFromService() override;

};

#endif // DAPNETIDCOMMAND_H
