/****************************************************************************
**
** This file is part of the libdap-qt-ui-chain-wallet library.
** 
** The class implements the functionality of creating a new wallet.
**
****************************************************************************/

#ifndef DAPNETWORKGOTOCOMMAND_H
#define DAPNETWORKGOTOCOMMAND_H

#include <QProcess>
#include <QString>

#include "DapAbstractCommand.h"
#include "DapNetwork.h"


class DapNetworkGoToCommand : public DapAbstractCommand
{
public:
    static const QString NETWORK_NAME;
    static const QString STATE;
    static const QString TARGET_STATE;

    /// Overloaded constructor.
    /// @param asServiceName Service name.
    /// @param parent Parent.
    /// @details The parent must be either DapRPCSocket or DapRPCLocalServer.
    explicit DapNetworkGoToCommand(const QString &asServicename, QObject *parent, const QString &asCliPath = QString());

public slots:
    /// Send a response to the client.
    /// @details Performed on the service side.
    /// @param arg1...arg10 Parameters.
    /// @return Reply to client.
    QVariant respondToClient(const QVariant &args = QVariant()) override;
    /// Reply from service.
    /// @details Performed on the service side.
    /// @return Service reply.
    void replyFromService() override;

    };

#endif // DAPNETWORKGOTOCOMMAND_H
