#include "DapNodeDel.h"

DapNodeDel::DapNodeDel(const QString &asServicename, QObject *parent, const QString &asCliPath)
    : DapAbstractCommand(asServicename, parent, asCliPath)
{
}

QVariant DapNodeDel::respondToClient(const QVariant &args)
{
    DapAbstractCommand::respondToClient(args);

    QJsonObject resultObj;

    auto result = cmdList->delNode(args).toString();
    if(!result.isEmpty())
    {
        if(result.contains("deleted"))
        {
            resultObj.insert(RESULT_KEY, QString("successfully"));
        }
        else
        {
            resultObj.insert(ERROR_KEY, result);
        }
    }
    else
    {
        resultObj.insert(ERROR_KEY, QString("Node is offline"));
    }
    addWeb3Result(resultObj, args);

    QJsonDocument resultDoc(resultObj);
    return resultDoc.toJson();
}
