#include "DapNodeDumpCommand.h"

DapNodeDumpCommand::DapNodeDumpCommand(const QString &asServicename, QObject *parent, const QString &asCliPath)
    : DapAbstractCommand(asServicename, parent, asCliPath)
{
}


/// Send a response to the client.
/// @details Performed on the service side.
/// @param arg1...arg10 Parameters.
/// @return Reply to client.
QVariant DapNodeDumpCommand::respondToClient(const QVariant &args)
{
    DapAbstractCommand::respondToClient(args);

    QStringList params = args.toStringList();
    auto net = params[0];

    auto result = cmdList->nodeDumpCommand(net).toString();

    QJsonObject resultObj;
    if(result.contains("Node addr"))
    {
        resultObj.insert(RESULT_KEY, result);
    }
    else
    {
        resultObj.insert(ERROR_KEY, result);
    }

    addWeb3Result(resultObj, args);
    QJsonDocument resultDoc(resultObj);
    return resultDoc.toJson();
}
