#include "DapNodeRestart.h"
#include <dapconfigreader.h>
#include <QSettings>
#include <QFile>

DapNodeRestart::DapNodeRestart(const QString &asServicename, QObject *parent, const QString &asCliPath)
    : DapAbstractCommand(asServicename, parent, asCliPath)
{
}

QVariant DapNodeRestart::respondToClient(const QVariant &args)
{
    DapAbstractCommand::respondToClient(args);

    // restart node
    cmdList->restartNode();

    QJsonDocument resultDoc(QJsonObject({{RESULT_KEY, QString("")}}));
    return resultDoc.toJson();
}

void DapNodeRestart::replyFromService()
{
    DapRpcServiceReply *reply = static_cast<DapRpcServiceReply *>(sender());
    QVariant replyVariant = reply->response().toJsonValue().toVariant();

    QJsonDocument replyDoc = QJsonDocument::fromJson(replyVariant.toByteArray());
    QJsonObject replyObj = replyDoc.object();
    QString resultStr = replyObj[RESULT_KEY].toString();

    emit serviceResponded(resultStr);
}
