#include "DapRemoveChainsOrGdbCommand.h"

/// Overloaded constructor.
/// @param asServiceName Service name.
/// @param parent Parent.
/// @details The parent must be either DapRPCSocket or DapRPCLocalServer.
/// @param asCliPath The path to cli nodes.
DapRemoveChainsOrGdbCommand::DapRemoveChainsOrGdbCommand(const QString &asServicename, QObject *parent, const QString &asCliPath)
    : DapAbstractCommand(asServicename, parent, asCliPath)
{
}

/// Send a response to the client.
/// @details Performed on the service side.
/// @param arg1 Network array. Format "<network name 1>:<chain 1>:<address 1>/<network name 2>:<chain 2>:<address 2>/..."
/// @return Reply to client.
QVariant DapRemoveChainsOrGdbCommand::respondToClient(const QVariant &args)
{
    DapAbstractCommand::respondToClient(args);
    QString result = cmdList->removeChainsOrGdb(args).toString();

    QJsonDocument resultDoc(QJsonObject{{RESULT_KEY, result}});
    return resultDoc.toJson();
}

void DapRemoveChainsOrGdbCommand::replyFromService()
{
    DapRpcServiceReply *reply = static_cast<DapRpcServiceReply *>(sender());
    QVariant replyVariant = reply->response().toJsonValue().toVariant();

    QJsonDocument replyDoc = QJsonDocument::fromJson(replyVariant.toByteArray());
    QJsonObject replyObj = replyDoc.object();
    QString resultStr = replyObj[RESULT_KEY].toString();

    emit serviceResponded(resultStr);
}
