#include "DapRemoveTransactionsQueueCommand.h"
#include "TransactionQueue/DapTransactionQueueController.h"
/// Overloaded constructor.
/// @param asServiceName Service name.
/// @param apSocket Client connection socket with service.
/// @param parent Parent.
DapRemoveTransactionsQueueCommand::DapRemoveTransactionsQueueCommand(const QString &asServicename, QObject *parent, const QString &asCliPath)
    : DapAbstractCommand(asServicename, parent, asCliPath)
{

}

/// Send a response to the client.
/// A log file is saved from the GUI window.
/// @param arg1...arg10 Parameters.
/// @return Reply to client.
QVariant DapRemoveTransactionsQueueCommand::respondToClient(const QVariant &args)
{
    DapAbstractCommand::respondToClient(args);
    DapTransactionQueueController* controller = DapTransactionQueueController::getTransactionController();
    QStringList params = args.toStringList();
    if(params.contains(WEB3_KEY))
    {
        auto resultObject = controller->tryRemoveTransactionsWithParams(args);
        addWeb3Result(resultObject, args);

        QJsonDocument resultDoc;
        resultDoc.setObject(resultObject);
        return resultDoc.toJson();
    }
    return controller->tryRemoveTransactions(args);
}

