/****************************************************************************
**
** This file is part of the libdap-qt-ui-chain-wallet library.
**
** The class implements the functionality of creating a new wallet.
**
****************************************************************************/

#ifndef DAPREMOVEWALLETCOMMAND_H
#define DAPREMOVEWALLETCOMMAND_H

#include <QProcess>
#include <QString>

#include "DapAbstractCommand.h"

class DapRemoveWalletCommand : public DapAbstractCommand
{
public:

    static const QString SUCCESS;
    static const QString MESSAGE;

    /// Overloaded constructor.
    /// @param asServiceName Service name.
    /// @param parent Parent.
    /// @details The parent must be either DapRPCSocket or DapRPCLocalServer.
    explicit DapRemoveWalletCommand(const QString &asServicename, QObject *parent = nullptr, const QString &asCliPath = QString());

private:

    QString WALLETS_PATH;
    QString getWalletsDir();

public slots:
    /// Send a response to the client.
    /// @details Performed on the service side.
    /// @param arg1...arg10 Parameters.
    /// @return Reply to client.
    QVariant respondToClient(const QVariant &args = QVariant()) override;
    /// Reply from service.
    /// @details Performed on the service side.
    /// @return Service reply.
    void replyFromService() override;

};

#endif // DAPREMOVEWALLETCOMMAND_H
