#include "DapRunCmdCommand.h"

/// Overloaded constructor.
/// @param asServiceName Service name.
/// @param parent Parent.
/// @details The parent must be either DapRPCSocket or DapRPCLocalServer.
/// @param asCliPath The path to cli nodes.
DapRunCmdCommand::DapRunCmdCommand(const QString &asServicename, QObject *parent, const QString &asCliPath, const QString &asToolPath)
    : DapAbstractCommand(asServicename, parent, asCliPath, asToolPath)
    , m_sToolPath(asToolPath)
{

}

/// Send a response to the client.
/// @details Performed on the service side.
/// @param arg1 Command.
/// @param arg2...arg10 Parameters.
/// @return Reply to client.
QVariant DapRunCmdCommand::respondToClient(const QVariant &args)
{
    DapAbstractCommand::respondToClient(args);
    QStringList params = args.toStringList();

    QVariant v_result = cmdList->runCmd(args).toString();

    // if json :
    if(v_result.type() == QMetaType::QJsonDocument) {
        qWarning() << "NEED JSON PARSING";
        QJsonArray temp_arr;
        return temp_arr;
    }

    // if string :
    QString result = v_result.toString();

    QJsonArray response;
    response.append(QJsonValue(params.first()));
    response.append(QJsonValue(result));

    return response;
}
