#ifndef DAPRUNCMDCOMMAND_H
#define DAPRUNCMDCOMMAND_H

#include <QProcess>

#include "DapAbstractCommand.h"

class DapRunCmdCommand : public DapAbstractCommand
{
public:
    /// Overloaded constructor.
    /// @param asServiceName Service name.
    /// @param parent Parent.
    /// @details The parent must be either DapRPCSocket or DapRPCLocalServer.
    /// @param asCliPath The path to cli nodes.
    DapRunCmdCommand(const QString &asServicename, QObject *parent = nullptr, const QString &asCliPath = QString(), const QString &asToolPath = QString());

    QString m_sToolPath;
public slots:
    /// Send a response to the client.
    /// @details Performed on the service side.
    /// @param arg1 Command.
    /// @param arg2...arg10 Parameters.
    /// @return Reply to client.
    QVariant respondToClient(const QVariant &args = QVariant()) override;
};

#endif // DAPRUNCMDCOMMAND_H
