#include "DapServiceInitCommand.h"

DapServiceInitCommand::DapServiceInitCommand(const QString &asServicename, QObject *parent, const QString &asCliPath)
: DapAbstractCommand(asServicename, parent, asCliPath)
{

}

void DapServiceInitCommand::notifedFromService(const QVariant &args)
{
    emit clientNotifed(args);
}

void DapServiceInitCommand::notifedFromClient(const QVariant &args)
{
    emit clientResponded(args);
}

void DapServiceInitCommand::notifyToClient(const QVariant &args)
{
    QJsonDocument doc = QJsonDocument::fromJson(args.toByteArray());

    DapRpcLocalServer * server = dynamic_cast<DapRpcLocalServer *>(m_parent);

    Q_ASSERT(server);

    DapRpcMessage request = DapRpcMessage::createNotification(QString("%1.%2").arg(this->getName()).arg("notifedFromService"), doc.toJson());
    server->notifyConnectedClients(request);
}
