#include "DapSrvStakeInvalidate.h"

DapSrvStakeInvalidate::DapSrvStakeInvalidate(const QString &asServicename, QObject *parent, const QString &asCliPath)
    : DapAbstractCommand(asServicename, parent, asCliPath)
{
}

QVariant DapSrvStakeInvalidate::respondToClient(const QVariant &args)
{
    DapAbstractCommand::respondToClient(args);

    QJsonObject resultObj;
    auto request = cmdList->getJsonResult(cmdList->srvStakeInvalidate(args), "DapSrvStakeInvalidate");
    QString error = QString();

    if(!error.isEmpty())
    {
        error = request.error.toString();
    }
    QString hash = QString();
    QString status = QString();
    if(error.isEmpty())
    {
        if(cmdList->testJsonBlock(request.result.isNull(), "the result block was not found", "DapSrvStakeInvalidate"))
        {
            auto tmpArray = request.result.toArray();
            if(!cmdList->testJsonBlock(tmpArray.isEmpty(), "the array is empty", "DapSrvStakeInvalidate"))
            {
                error = "result is not an array";
            }
            else
            {
                auto tmpFObject = tmpArray[0].toObject();
                if(!cmdList->testJsonBlock(!tmpFObject.contains("tx_hash"), "the error tx_hash block is missing", "DapSrvStakeInvalidate"))
                {
                    error = "The output of the node has changed. Hash not found";
                }
                else
                {
                    hash = tmpFObject["tx_hash"].toString();
                }
                if(!cmdList->testJsonBlock(!tmpFObject.contains("status"), "the error status block is missing", "DapSrvStakeInvalidate"))
                {
                    error = "The output of the node has changed. Status not found";
                }
                else
                {
                    status = tmpFObject["status"].toString();
                }
            }
        }
    }
    else
    {
        if(cmdList->testJsonBlock(request.error.isNull(), "the error block was not found", "DapSrvStakeInvalidate"))
        {
            auto tmpArray = request.error.toArray();
            if(!cmdList->testJsonBlock(tmpArray.isEmpty(), "the array is empty", "DapSrvStakeInvalidate"))
            {
                error = "result is not an array";
            }
            else
            {
                auto tmpFObject = tmpArray[0].toObject();
                if(!cmdList->testJsonBlock(!tmpFObject.contains("code"), "the code hash block is missing", "DapSrvStakeInvalidate"))
                {
                    error = "The output of the node has changed. No error code";
                }
                else
                {
                    error = "Error code: " + tmpFObject["code"].toString();
                }
                if(!cmdList->testJsonBlock(!tmpFObject.contains("message"), "the error message block is missing", "DapSrvStakeInvalidate"))
                {
                    error += "The output of the node has changed. No error message";
                }
                else
                {
                    error += " messge: " + tmpFObject["message"].toString();
                }
            }
        }
    }
    QJsonObject resultObject;
    QJsonObject mainResult;
    if(!hash.isEmpty())
    {
        mainResult.insert("success",QJsonValue(true));
        mainResult.insert("message",QJsonValue("VPN order successfully created"));
        mainResult.insert("tx_hash",QJsonValue(hash));
    }
    else
    {
        mainResult.insert("success",QJsonValue(false));
        mainResult.insert("message",QJsonValue(error));
        resultObject.insert(ERROR_KEY, QJsonValue(error));
    }
    resultObject.insert(RESULT_KEY, mainResult);
    QJsonDocument resultDoc;
    resultDoc.setObject(resultObject);
    return resultDoc.toJson();
}
