#include "DapStakeLockHoldCommand.h"

DapStakeLockHoldCommand::DapStakeLockHoldCommand(const QString &asServicename, QObject *parent, const QString &asCliPath)
    : DapAbstractCommand(asServicename, parent, asCliPath)
{
}

QVariant DapStakeLockHoldCommand::respondToClient(const QVariant &args)
{
    DapAbstractCommand::respondToClient(args);

    QJsonObject resultObject;

    QVariant v_result = cmdList->stakeLockHold(args);
    QJsonObject mainResult;
    QString result = v_result.toString();

    if(result.contains("TX STAKE LOCK CREATED"))
    {
        mainResult.insert(SUCCESS,QJsonValue(true));
        mainResult.insert(MESSAGE,QJsonValue(result));

        QRegularExpressionMatch match = REGULAR_HASH.match(result);
        if(match.hasMatch())
        {
            mainResult.insert(HASH, QJsonValue(match.captured(1)));
        }
    }
    else
    {
        mainResult.insert(SUCCESS,QJsonValue(false));
        mainResult.insert(MESSAGE,QJsonValue(result));
        resultObject.insert(ERROR_KEY, result);
    }
    resultObject.insert(RESULT_KEY, mainResult);
    addWeb3Result(resultObject, args);
    QJsonDocument resultDoc;

    resultDoc.setObject(resultObject);

    return resultDoc.toJson();
}

