#pragma once

#include <QString>

#include "DapAbstractCommand.h"

class DapStakeLockTakeCommand : public DapAbstractCommand
{
public:
    DapStakeLockTakeCommand(const QString &asServicename, QObject *parent = nullptr, const QString &asCliPath = QString());

public slots:
    /// Send a response to the client.
    /// @details Performed on the service side.
    /// @param arg1...arg10 Parameters.
    /// @return Reply to client.
    QVariant respondToClient(const QVariant &args = QVariant()) override;

protected:
    const QRegularExpression REGULAR_HASH = QRegularExpression(R"(TAKE_TX_DATUM_HASH = (.\S+))");

    const QString SUCCESS = "success";
    const QString MESSAGE = "message";
    const QString HASH = "tx_hash";
};

