#ifndef DAPTOKENEMISSIONCOMMAND_H
#define DAPTOKENEMISSIONCOMMAND_H

#include <QProcess>
#include <QString>

#include "DapAbstractCommand.h"

class DapTokenEmissionCommand : public DapAbstractCommand
{
public:

    static const QString SUCCESS;
    static const QString MESSAGE;

    /// Overloaded constructor.
    /// @param asServiceName Service name.
    /// @param parent Parent.
    /// @details The parent must be either DapRPCSocket or DapRPCLocalServer.
    /// @param asCliPath The path to cli nodes.
    DapTokenEmissionCommand(const QString &asServicename, QObject *parent = nullptr, const QString &asCliPath = QString());

    /// Send a response to the client.
    /// @details Performed on the service side.
    /// @param arg1...arg10 Parameters.
    /// @return Reply to client.
    QVariant respondToClient(const QVariant &args = QVariant()) override;
    /// Reply from service.
    /// @details Performed on the service side.
    /// @return Service reply.
    void replyFromService() override;
};

#endif // DAPTOKENEMISSIONCOMMAND_H
