#pragma once

#include "DapAbstractCommand.h"

class DapVoitingDumpCommand : public DapAbstractCommand
{
public:
    explicit DapVoitingDumpCommand(const QString &asServicename, QObject *parent = nullptr, const QString &asCliPath = QString());

public slots:
    QVariant respondToClient(const QVariant &args = QVariant()) override;

private:
    const QString HASH_NODE_KEY = "poll_tx";
    const QString RESULTS_NODE_KEY = "results";
    const QString QUESTION_NODE_KEY = "question";

    const QString OPTION_ID_NODE_KEY = "option_id";
    const QString VOTE_TX_NODE_KEY = "option_text";
    const QString VOTING_POWER_NODE_KEY = "votes_count";
    const QString VOTE_SHARE_NODE_KEY = "votes_percent";
    const QString VOTE_SUM_NODE_KEY = "votes_sum";
    const QString VOTE_SUM_DATOSHI_NODE_KEY = "votes_sum_datoshi";
    const QString VOTE_SUM_WEIGHT_NODE_KEY = "votes_sum_weight";

    const QString VOTES_COUNT_NODE_KEY = "votes_count";
    const QString TOTAL_SUM_NODE_KEY = "total_sum";
    const QString TOTAL_SUM_DATOSHI_NODE_KEY = "total_sum_datoshi";
    const QString TOKEN_NODE_KEY = "token";


    const QString HASH_KEY = "hash";
    const QString QUESTION_KEY = "question";
    const QString MESSAGE_KEY = "message";

    const QString MUMBER_KEY = "number";
    const QString OPTION_KEY = "option";
    const QString COUNT_KEY = "count";
    const QString PERCENT_KEY = "percent";
    const QString VOTES_KEY = "votes";
    const QString COIN_KEY = "coin";
    const QString DATOSHI_KEY = "datoshi";
    const QString WEIGHT_KEY = "weight";

    const QString OPTIONS_KEY = "options";
    const QString TOTAL_NAMBER_KEY = "totalNamber";
    const QString TOTAL_COINS_KEY = "totalCoins";
    const QString TOTAL_DATOSHI_KEY = "totalDatoshi";
    const QString TOKEN_KEY = "token";
};
