#ifndef DAPWALLETACTIVATEORDEACTIVATECOMMAND_H
#define DAPWALLETACTIVATEORDEACTIVATECOMMAND_H

#include <QProcess>

#include "DapAbstractCommand.h"

class DapWalletActivateOrDeactivateCommand : public DapAbstractCommand
{
public:
    explicit DapWalletActivateOrDeactivateCommand(const QString &asServicename, QObject *parent = nullptr, const QString &asCliPath = QString());

public slots:
    /// Send a response to the client.
    /// @details Performed on the service side.
    /// @param arg1...arg10 Parameters.
    /// @return Reply to client.
    QVariant respondToClient(const QVariant &args = QVariant()) override;
    /// Reply from service.
    /// @details Performed on the service side.
    /// @return Service reply.
    void replyFromService() override;


};


#endif // DAPWALLETACTIVATEORDEACTIVATECOMMAND_H
