#include "DapWebConnectRequest.h"


DapWebConnectRequest::DapWebConnectRequest(const QString &asServicename, QObject *parent, const QString &asCliPath)
: DapAbstractCommand(asServicename, parent, asCliPath)
{

}

void DapWebConnectRequest::notifedFromService(const QVariant &args)
{
    emit clientNotifed(args);
}

void DapWebConnectRequest::notifedFromClient(const QVariant &args)
{
    emit clientResponded(args);
}

void DapWebConnectRequest::notifyToClient(const QVariant &args)
{

    QJsonDocument doc = QJsonDocument::fromVariant(args);

    DapRpcLocalServer * server = dynamic_cast<DapRpcLocalServer *>(m_parent);

    Q_ASSERT(server);

    DapRpcMessage request = DapRpcMessage::createNotification(QString("%1.%2").arg(this->getName()).arg("notifedFromService"), doc.toJson());
    server->notifyConnectedClients(request);
}

