#ifndef DAPWEBCONNECTREQUEST_H
#define DAPWEBCONNECTREQUEST_H

#include "DapAbstractCommand.h"


class DapWebConnectRequest : public DapAbstractCommand
{
public:
    DapWebConnectRequest(const QString &asServicename, QObject *parent = nullptr, const QString &asCliPath = QString());

public slots:
    /// Process the notification from the client on the service side.
    /// @details Performed on the service side.
    /// @param arg1 Command.
    /// @param arg2...arg10 Parameters.

    void notifedFromService(const QVariant &args = QVariant()) override;
    void notifedFromClient(const QVariant &args = QVariant()) override;
    void notifyToClient(const QVariant &args = QVariant()) override;

};

#endif // DAPWEBCONNECTREQUEST_H
