#ifndef DAPXCHANGEORDERCREATE_H
#define DAPXCHANGEORDERCREATE_H

#include <QProcess>
#include <QString>

#include "DapAbstractCommand.h"

class DapXchangeOrderCreate : public DapAbstractCommand
{
public:
    DapXchangeOrderCreate(const QString &asServicename, QObject *parent = nullptr, const QString &asCliPath = QString());

public slots:
    /// Send a response to the client.
    /// @details Performed on the service side.
    /// @param arg1...arg10 Parameters.
    /// @return Reply to client.
    QVariant respondToClient(const QVariant &args = QVariant()) override;
    /// Reply from service.
    /// @details Performed on the service side.
    /// @return Service reply.
    void replyFromService() override;

protected:
    const QRegularExpression REGULAR_HASH = QRegularExpression(R"(order (.\S+))");

    const QString SUCCESS = "success";
    const QString MESSAGE = "message";
    const QString HASH = "tx_hash";
};

#endif // DAPXCHANGEORDERCREATE_H
