#ifndef DAPXCHANGEORDERREMOVE_H
#define DAPXCHANGEORDERREMOVE_H

#include <QProcess>
#include <QString>

#include "DapAbstractCommand.h"

class DapXchangeOrderRemove : public DapAbstractCommand
{
public:

    static const QString SUCCESS;
    static const QString MESSAGE;

    DapXchangeOrderRemove(const QString &asServicename, QObject *parent = nullptr, const QString &asCliPath = QString());

public slots:
    /// Send a response to the client.
    /// @details Performed on the service side.
    /// @param arg1...arg10 Parameters.
    /// @return Reply to client.
    QVariant respondToClient(const QVariant &args = QVariant()) override;
    /// Reply from service.
    /// @details Performed on the service side.
    /// @return Service reply.
    void replyFromService() override;

private:
    const QRegularExpression REGULAR_HASH = QRegularExpression(R"(hash (.\S+))");

    const QString HASH = "tx_hash";
};

#endif // DAPXCHANGEORDERREMOVE_H
