#pragma once
#include "../DapCreateJsonTransactionCommand.h"
#include "DapCommandStackManager.h"

#include <QMap>
#include <QJsonDocument>

class DapCreateJsonTransactionCommandStack : public DapCreateJsonTransactionCommand
{
    enum DataType
    {
        NET = 0,
        ADDRESS,
        FEE,
        TOKEN,
        WALLET_NAME,
        VALUE
    };

public:
    DapCreateJsonTransactionCommandStack(const QString &asServicename, QObject *parent = nullptr, const QString &asCliPath = QString());
    ~DapCreateJsonTransactionCommandStack();
public slots:
    QVariant respondToClient(const QVariant &args = QVariant()) override;
private:
    QString getData(const QStringList& list, DataType type);

private:
    DapCommandStackManager* m_commandManager = nullptr;
};

