#pragma once
#include "../DapOrderCreateStakerCommand.h"
#include "DapCommandStackManager.h"

class DapOrderCreateStakerCommandStack : public DapOrderCreateStakerCommand
{
public:
    DapOrderCreateStakerCommandStack(const QString &asServicename, QObject *parent = nullptr, const QString &asCliPath = QString());
    ~DapOrderCreateStakerCommandStack();
public slots:
    QVariant respondToClient(const QVariant &args = QVariant()) override;
private:
    DapCommandStackManager* m_commandManager = nullptr;

    const QMap<QString, QPair<QString, QString>> m_tokens = {{"Backbone", qMakePair(QString("mCELL"), QString("CELL"))},
                                                             {"KelVPN", qMakePair(QString("mKEL"), QString("KEL"))},
                                                             {"raiden", qMakePair(QString("mtCELL"), QString("tCELL"))},
                                                             {"riemann", qMakePair(QString("mtKEL"), QString("tKEL"))},
                                                             {"mileena", qMakePair(QString("mtMIL"), QString("tMIL"))},
                                                             {"subzero", qMakePair(QString("mtCELL"), QString("tCELL"))}};
};

