#include "DapXchangeOrderCreateStack.h"
#include "TransactionQueue/DapTransactionQueueController.h"

DapXchangeOrderCreateStack::DapXchangeOrderCreateStack(const QString &asServicename, QObject *parent, const QString &asCliPath)
    : DapXchangeOrderCreate(asServicename, parent, asCliPath)
    , m_commandManager(new DapCommandStackManager(this))
{
    m_commandManager->setCommandCalback([&](const QVariant &args) -> QVariant { return this->respondToClient(args);});
    m_commandManager->setParentCalback([&](const QVariant &args) -> QVariant { return DapXchangeOrderCreate::respondToClient(args); });
    m_commandManager->setWalletNameCalback([&](const QStringList &list) -> QString { return list[3]; });
    m_commandManager->setNetworkNameCalback([&](const QStringList &list) -> QString { return list[0];});

    DapTransactionQueueController* controller = DapTransactionQueueController::getTransactionController();
    DapTransactionQueueController::ParamsFromCommand callbacks;
    callbacks.addressCallback       = [](const QStringList &list) -> QString { return QString();};
    callbacks.feeCallback           = [](const QStringList &list) -> QString { return list[6];};
    callbacks.tokenCallback         = [](const QStringList &list) -> QString { return list[1];};
    callbacks.valueCallback         = [](const QStringList &list) -> QString { return list[4];};
    callbacks.walletNameCallback    = [](const QStringList &list) -> QString { return list[3];};
    callbacks.directionCallback     = [](const QStringList &list) -> QString { return "to";};
    callbacks.testExpenses          = []() -> bool { return true;};
    callbacks.feeInfo               = [&]() -> const QMap<QString, NetworkSpace::FeeInfoStruct> { return getFee();};
    controller->setParamsCommandCallback(this->getName(), callbacks);
}

QVariant DapXchangeOrderCreateStack::respondToClient(const QVariant &args)
{
    return m_commandManager->respondToClient(args);
}

DapXchangeOrderCreateStack::~DapXchangeOrderCreateStack()
{
    delete m_commandManager;
}
