#include "DapXchangeOrderRemoveStack.h"
#include "TransactionQueue/DapTransactionQueueController.h"

DapXchangeOrderRemoveStack::DapXchangeOrderRemoveStack(const QString &asServicename, QObject *parent, const QString &asCliPath)
    : DapXchangeOrderRemove(asServicename, parent, asCliPath)
    , m_commandManager(new DapCommandStackManager(this))
{
    m_commandManager->setCommandCalback([&](const QVariant &args) -> QVariant { return this->respondToClient(args);});
    m_commandManager->setParentCalback([&](const QVariant &args) -> QVariant { return DapXchangeOrderRemove::respondToClient(args); });
    m_commandManager->setWalletNameCalback([&](const QStringList &list) -> QString { return list[2]; });
    m_commandManager->setNetworkNameCalback([&](const QStringList &list) -> QString { return list[0];});

    DapTransactionQueueController* controller = DapTransactionQueueController::getTransactionController();
    DapTransactionQueueController::ParamsFromCommand callbacks;
    callbacks.addressCallback       = [](const QStringList &list) -> QString { return QString();};
    callbacks.feeCallback           = [](const QStringList &list) -> QString { return list[3];};
    callbacks.tokenCallback         = [](const QStringList &list) -> QString { return list[4];};
    callbacks.valueCallback         = [](const QStringList &list) -> QString { return list[5];};
    callbacks.walletNameCallback    = [](const QStringList &list) -> QString { return list[2];};
    callbacks.directionCallback     = [](const QStringList &list) -> QString { return "from";};
    callbacks.testExpenses          = []() -> bool { return false;};
    callbacks.feeInfo               = [&]() -> const QMap<QString, NetworkSpace::FeeInfoStruct> { return getFee();};
    controller->setParamsCommandCallback(this->getName(), callbacks);
    controller->addCommandWithoutInfoWallet(this->getName());
}

QVariant DapXchangeOrderRemoveStack::respondToClient(const QVariant &args)
{
    return m_commandManager->respondToClient(args);
}

DapXchangeOrderRemoveStack::~DapXchangeOrderRemoveStack()
{
    delete m_commandManager;
}
