import QtQuick 2.0
import "qrc:/"


Item
{
    ///@details dapFont ID of item with all project fonts.
    property alias dapFont: dapFontsObjects
    ///@details dapFactor Scaling factor.
    property int dapFactor: 1

    //Add Font Loader
    DapFont
    {
        id: dapFonts
        dapFontPath: "qrc:/resources/fonts/Quicksand/"
        dapFontNames: ["Quicksand-Bold.ttf",
                    "Quicksand-Light.ttf",
                    "Quicksand-Medium.ttf",
                    "Quicksand-Regular.ttf",     //3
                    "Quicksand-SemiBold.ttf",
                    "Quicksand-VariableFont_wght.ttf"]
    }
    QtObject
    {
        id:dapFontsObjects


        property font bold12:                  Qt.font({
                                                                        family: dapFonts.dapProjectFonts[0].name,
                                                                        bold: true,
                                                                        italic: false,
                                                                        pixelSize: 12 * dapFactor
                                                                    })
        property font bold14:                  Qt.font({
                                                                        family: dapFonts.dapProjectFonts[0].name,
                                                                        bold: true,
                                                                        italic: false,
                                                                        pixelSize: 14 * dapFactor
                                                                    })

        property font bold15:                  Qt.font({
                                                                        family: dapFonts.dapProjectFonts[0].name,
                                                                        bold: true,
                                                                        italic: false,
                                                                        pixelSize: 15 * dapFactor
                                                                    })

        property font bold17:                  Qt.font({
                                                                        family: dapFonts.dapProjectFonts[0].name,
                                                                        bold: true,
                                                                        italic: false,
                                                                        pixelSize: 17 * dapFactor
                                                                    })

        property font bold20:                  Qt.font({
                                                                        family: dapFonts.dapProjectFonts[0].name,
                                                                        bold: true,
                                                                        italic: false,
                                                                        pixelSize: 20 * dapFactor
                                                                    })

        ///@details light10 Font of Quicksand font family (light, 10pt)
        property font light10:                 Qt.font({
                                                                        family: dapFonts.dapProjectFonts[1].name,
                                                                        bold: false,
                                                                        italic: false,
                                                                        pixelSize: 10 * dapFactor
                                                                    })


        ///@details light12 Font of Quicksand font family (light, 12pt)
        property font light12:                 Qt.font({
                                                                        family: dapFonts.dapProjectFonts[1].name,
                                                                        bold: false,
                                                                        italic: false,
                                                                        pixelSize: 12 * dapFactor
                                                                    })


        ///@details light14 Font of Quicksand font family (light, 14pt)
        property font light14:                 Qt.font({
                                                                        family: dapFonts.dapProjectFonts[1].name,
                                                                        bold: false,
                                                                        italic: false,
                                                                        pixelSize: 14 * dapFactor
                                                                    })


        ///@details light16 Font of Quicksand font family (light, 16pt)
        property font light16:                 Qt.font({
                                                                        family: dapFonts.dapProjectFonts[1].name,
                                                                        bold: false,
                                                                        italic: false,
                                                                        pixelSize: 16 * dapFactor
                                                                    })


        ///@details light27 Font of Quicksand font family (light, 27pt)
        property font light27:                 Qt.font({
                                                                        family: dapFonts.dapProjectFonts[1].name,
                                                                        bold: false,
                                                                        italic: false,
                                                                        pixelSize: 27 * dapFactor
                                                                    })


        ///@details dapFontQuicksandightCustom Font of Quicksand font family (light, without parameters)
        property font lightCustom:             Qt.font({   family: dapFonts.dapProjectFonts[1].name })


        property font normal12:                Qt.font({
                                                                        family: dapFonts.dapProjectFonts[2].name,
                                                                        bold: false,
                                                                        italic: false,
                                                                        pixelSize: 12 * dapFactor
                                                                    })

        property font medium10:                Qt.font({
                                                                        family: dapFonts.dapProjectFonts[2].name,
                                                                        bold: true,
                                                                        italic: false,
                                                                        pixelSize: 10 * dapFactor
                                                                    })

        property font medium11:                Qt.font({
                                                                        family: dapFonts.dapProjectFonts[2].name,
                                                                        bold: true,
                                                                        italic: false,
                                                                        pixelSize: 11 * dapFactor
                                                                    })

        property font medium12:                Qt.font({
                                                                        family: dapFonts.dapProjectFonts[2].name,
                                                                        bold: true,
                                                                        italic: false,
                                                                        pixelSize: 12 * dapFactor
                                                                    })

        property font medium13:                Qt.font({
                                                                        family: dapFonts.dapProjectFonts[2].name,
                                                                        bold: true,
                                                                        italic: false,
                                                                        pixelSize: 13 * dapFactor
                                                                    })


        property font medium14:                Qt.font({
                                                                        family: dapFonts.dapProjectFonts[2].name,
                                                                        bold: true,
                                                                        italic: false,
                                                                        pixelSize: 14 * dapFactor
                                                                    })

        property font medium15:                Qt.font({
                                                                        family: dapFonts.dapProjectFonts[2].name,
                                                                        bold: true,
                                                                        italic: false,
                                                                        pixelSize: 15 * dapFactor
                                                                    })


        property font medium16:                Qt.font({
                                                                        family: dapFonts.dapProjectFonts[2].name,
                                                                        bold: true,
                                                                        italic: false,
                                                                        pixelSize: 16 * dapFactor
                                                                    })


        property font medium18:                Qt.font({
                                                                        family: dapFonts.dapProjectFonts[2].name,
                                                                        bold: true,
                                                                        italic: false,
                                                                        pixelSize: 18 * dapFactor
                                                                    })

        property font medium20:                Qt.font({
                                                                        family: dapFonts.dapProjectFonts[2].name,
                                                                        bold: true,
                                                                        italic: false,
                                                                        pixelSize: 20 * dapFactor
                                                                    })

        property font medium24:                Qt.font({
                                                                        family: dapFonts.dapProjectFonts[2].name,
                                                                        bold: true,
                                                                        italic: false,
                                                                        pixelSize: 24 * dapFactor
                                                                    })


        property font medium26:                Qt.font({
                                                                        family: dapFonts.dapProjectFonts[2].name,
                                                                        bold: true,
                                                                        italic: false,
                                                                        pixelSize: 26 * dapFactor
                                                                    })


        property font medium27:                Qt.font({
                                                                        family: dapFonts.dapProjectFonts[2].name,
                                                                        bold: true,
                                                                        italic: false,
                                                                        pixelSize: 27 * dapFactor
                                                                    })

        property font medium28:                Qt.font({
                                                                        family: dapFonts.dapProjectFonts[2].name,
                                                                        bold: true,
                                                                        italic: false,
                                                                        pixelSize: 28 * dapFactor
                                                                    })

        property font mediumBold16:            Qt.font({
                                                                        family: dapFonts.dapProjectFonts[2].name,
                                                                        bold: true,
                                                                        italic: false,
                                                                        pixelSize: 16 * dapFactor
                                                                    })

        property font regular8:               Qt.font({
                                                                        family: dapFonts.dapProjectFonts[3].name,
                                                                        bold: false,
                                                                        italic: false,
                                                                        pixelSize: 8 * dapFactor
                                                                    })

        property font regular10:               Qt.font({
                                                                        family: dapFonts.dapProjectFonts[3].name,
                                                                        bold: false,
                                                                        italic: false,
                                                                        pixelSize: 10 * dapFactor
                                                                    })


        property font regular11:               Qt.font({
                                                                        family: dapFonts.dapProjectFonts[3].name,
                                                                        bold: false,
                                                                        italic: false,
                                                                        pixelSize: 11 * dapFactor
                                                                    })

        property font regular12:               Qt.font({
                                                                        family: dapFonts.dapProjectFonts[3].name,
                                                                        bold: false,
                                                                        italic: false,
                                                                        pixelSize: 12 * dapFactor
                                                                    })

        property font regular13:               Qt.font({
                                                                        family: dapFonts.dapProjectFonts[3].name,
                                                                        bold: false,
                                                                        italic: false,
                                                                        pixelSize: 13 * dapFactor
                                                                    })


        property font regular14:               Qt.font({
                                                                        family: dapFonts.dapProjectFonts[3].name,
                                                                        bold: false,
                                                                        italic: false,
                                                                        pixelSize: 14 * dapFactor
                                                                    })

        property font regular15:               Qt.font({
                                                                        family: dapFonts.dapProjectFonts[3].name,
                                                                        bold: false,
                                                                        italic: false,
                                                                        pixelSize: 15 * dapFactor
                                                                    })

        property font regular16:               Qt.font({
                                                                        family: dapFonts.dapProjectFonts[3].name,
                                                                        bold: false,
                                                                        italic: false,
                                                                        pixelSize: 16 * dapFactor
                                                                    })


        property font regular18:               Qt.font({
                                                                        family: dapFonts.dapProjectFonts[3].name,
                                                                        bold: false,
                                                                        italic: false,
                                                                        pixelSize: 18 * dapFactor
                                                                    })


        property font regular24:               Qt.font({
                                                                        family: dapFonts.dapProjectFonts[3].name,
                                                                        bold: false,
                                                                        italic: false,
                                                                        pixelSize: 24 * dapFactor
                                                                    })


        property font regular28:               Qt.font({
                                                                        family: dapFonts.dapProjectFonts[3].name,
                                                                        bold: false,
                                                                        italic: false,
                                                                        pixelSize: 28 * dapFactor
                                                                    })

        property font regularCustom:           Qt.font({   family: dapFonts.dapProjectFonts[3].name })

    }


}  //root




